/*
	** Copyright (C) 2009 Doubango Telecom <imsframework(at)gmail.com> 

	This file is part of 'Doubango IMS Client Framework'.

    'Doubango IMS Client Framework' is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    'Doubango IMS Client Framework' is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with 'Doubango IMS Client Framework'.  If not, see <http://www.gnu.org/licenses/>.

	** For commercial use, you must purchase a proprietary license from Doubango Telecom.
*/

/* Copyright (C) 2009 Doubango Telecom
*
* Authors:	F0076RTY <imsframework@gmail.com>
*
*/

#ifndef __DOUBANGO_SM_H__
#define __DOUBANGO_SM_H__

#include "pref.h"
#include <map>

PREF_NAMESPACE_START

/* state machine class*/
template<class STATE, class TYPE>
class sm
{
private:
	/* callback function definition */
	typedef void (TYPE::*callback)(void);
	
	TYPE *obj;

	std::map<STATE, callback> states;
	STATE state_cur;

public:
	/* state machine constructor */
	sm(TYPE *instance){ this->obj = instance; }
	/* state machine destructor */
	~sm(void){ }

	/* map the the state with the callback function */
	void map_state_callback(STATE state, callback cb){ this->states[state] = cb;}

	/* get the current state*/
	STATE get_state_curr(void){ return this->state_cur; }
	/* ste the current state */
	void set_state_curr(STATE state){ state_cur = state; }
	
	/* invoke/call the current state's callback function*/
	void invoke_state_curr(void)
	{
		callback cb = this->states[state_cur];
		if (cb) (this->obj->*callback)();
	}
};

PREF_NAMESPACE_END

#endif /* __DOUBANGO_SM_H__ */